# Demo submission

The demo submission is a example submission for the Spook CTF that successfully
runs under the evaluation framework and demonstrates usage of a tool to predict
intermediate values in the hardware implementation.
It performs a single byte recovery on the weaker targets. Details for the
hardware 2 shares implementation is available [here](demo_hw/README.md),
software 3 shares [here](demo_sw/README.md).

This demo is authored by Olivier Bronchain, Gaëtan Cassiers and Charles Momin from UCLouvain, 2020.

## Setup

The [setup](setup) script install all the tools required to run the hardware and software attacks provided with the submission. For this demo submission, it installs [stella\_zero](stella_zero/README.md) into /stella\_zero, [verilator](https://www.veripool.org/wiki/verilator) and some python [packages](requirements.txt). 

## Demo environment
The demo attacks provided are splitted in two phases: the profiling and the attacks itself. The different scripts executed for both targets are respectively located in [hw2/](hw2) and [sw3/](sw3). These scripts firsts setup the environment and then run the profiling or attack scripts on their own. Namely, for the sofware target, it adds stella\_zero to the Python environment (i.e., by modifying the PYTHONPATH variable) and then run some useful scripts that are located in [demo_sw](demo_sw). Similarly for the hardware target, the setup also adds stella\_zero to the Python environment. Additionally, the profile script also unzips the [hdl sources](https://git-crypto.elen.ucl.ac.be/cmomin/hw_ctf) and compiles it with verilator before lauching the appropriate scripts located in [demo_hw](demo_hw). 
